/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  libmemcached bindings
 *  Copyright (C) 2008 Monty Taylor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

class memcached_stat_st {
  memcached_stat_st();
  ~memcached_stat_st();
public:

#if !defined(SWIG_RUBY_AUTORENAME)
  %rename(pointerSize) pointer_size;
  %rename(rusageUserSeconds) rusage_user_seconds;
  %rename(rusageUserMicroseconds) rusage_user_microseconds;
  %rename(rusageSystemSeconds) rusage_system_seconds;
  %rename(rusageSystemMicroseconds) rusage_system_microseconds;
  %rename(currItems) curr_items;
  %rename(totalItems) total_items;
  %rename(limitMaxbytes) limit_maxbytes;
  %rename(currConnections) curr_connections;
  %rename(totalConnections) total_connections;
  %rename(connectionStructures) connection_structures;
  %rename(cmdGet) cmd_get;
  %rename(cmdSet) cmd_set;
  %rename(getHits) get_hits;
  %rename(getMisses) get_misses;
  %rename(bytesRead) bytes_read;
  %rename(bytesWritten) bytes_written;
#endif

  %immutable;
  uint32_t pid;
  uint32_t uptime;
  uint32_t threads;
  uint32_t time;
  uint32_t pointer_size;
  uint32_t rusage_user_seconds;
  uint32_t rusage_user_microseconds;
  uint32_t rusage_system_seconds;
  uint32_t rusage_system_microseconds;
  uint32_t curr_items;
  uint32_t total_items;
  uint64_t limit_maxbytes;
  uint32_t curr_connections;
  uint32_t total_connections;
  uint32_t connection_structures;
  uint64_t bytes;
  uint64_t cmd_get;
  uint64_t cmd_set;
  uint64_t get_hits;
  uint64_t get_misses;
  uint64_t evictions;
  uint64_t bytes_read;
  uint64_t bytes_written;
  %mutable;

};
