/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 *
 *  libmemcached bindings
 *  Copyright (C) 2008 Monty Taylor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */


%{
// TODO: Implement an actual exception selection
//#define THROW_exception(excp, msg) { throw_exception(jenv, #excp,msg);  }
#define THROW_exception(excp, msg) { throw_exception(jenv, "MemcachedException" ,msg);  }

  void throw_exception(JNIEnv *jenv, const char * excp, const char *msg) {
    jclass clazz = NULL;
    const char * prefix = "org/tangent/memcached/";
    if (strncmp(excp,"org.",4)==0) {
      clazz = jenv->FindClass(excp);
      if (clazz==NULL) {
        clazz = jenv->FindClass("java/lang/RuntimeException");
        jenv->ThrowNew(clazz,"Invalid exception class specified");
        return;
      }
    } else {
      char * exception = (char *)malloc(strlen(excp)+strlen(prefix)+1);
      strcpy(exception,prefix);
      strcat(exception,excp);

      clazz = jenv->FindClass(exception);
      free(exception);
      if (clazz==NULL) {
        clazz = jenv->FindClass("java/lang/RuntimeException");
        jenv->ThrowNew(clazz,"Invalid exception class specified");
        return;
      }
    }

    jenv->ThrowNew(clazz,msg);
    jenv->DeleteLocalRef(clazz);
  }


  %}
