AC_DEFUN([WITH_JAVA], [

  AC_ARG_WITH([java], 
    [AS_HELP_STRING([--with-java],
      [BULD NDB/J @<:@default=yes@:>@])],
    [with_java=$withval], 
    [with_java=java])

  AS_IF([test "x$with_java" != "xno"],[
    AS_IF([test "x$with_java" != "xyes"],[JAVA=$with_java])   
    AC_PROG_JAVA()
    AS_IF([test "x$JAVA" = "x"],AC_MSG_ERROR([Couldn't find java.]))
    AC_PROG_JAVAC()
    AS_IF([test "x$JAVAC" = "x"],AC_MSG_ERROR([Couldn't find javac.]))
    AC_PROG_JAR()
    AS_IF([test "x$JAR" = "x"],AC_MSG_ERROR([Couldn't find jar.]))
    AC_PROG_JAVADOC()
    AS_IF([test "x$JAVADOC" = "x"],AC_MSG_ERROR([Couldn't find javadoc.]))
    AC_CHECK_JUNIT()
    AC_CHECK_JAVA_CXXFLAGS()
    AC_JAVA_VERSION()
    SWAP_JDBC_RESULTSET()
    
    AS_IF([test "x$JAVAC" = "xno"],[
      AS_IF([test "w$with_java" = "xyes"],[
        AC_MSG_ERROR([Unknown or unsupported JDK])
      ],[
        with_java=no
      ])
    ])

  ])
])

